
% Some general shortcuts.
\newcommand{\eg}{e.\,g.\ }
\newcommand{\ie}{i.\,e.\ }


% Optical adjustments.
\renewcommand{\labelitemi}{--}


% Shortcuts to number sets.
\newcommand{\N}{\mathbb{N}}
\newcommand{\Z}{\mathbb{Z}}
\newcommand{\Q}{\mathbb{Q}}
\newcommand{\R}{\mathbb{R}}
\newcommand{\Rinfty}{\R \cup \{\infty\}}
\newcommand{\C}{\mathbb{C}}


% Shortcut to calligraphic letters.
\newcommand{\cA}{\mathcal A}
\newcommand{\cB}{\mathcal B}
\newcommand{\cC}{\mathcal C}
\newcommand{\cD}{\mathcal D}
\newcommand{\cE}{\mathcal E}
\newcommand{\cF}{\mathcal F}
\newcommand{\cG}{\mathcal G}
\newcommand{\cH}{\mathcal H}
\newcommand{\cI}{\mathcal I}
\newcommand{\cJ}{\mathcal J}
\newcommand{\cK}{\mathcal K}
\newcommand{\cL}{\mathcal L}
\newcommand{\cM}{\mathcal M}
\newcommand{\cN}{\mathcal N}
\newcommand{\cO}{\mathcal O}
\newcommand{\cP}{\mathcal P}
\newcommand{\cQ}{\mathcal Q}
\newcommand{\cR}{\mathcal R}
\newcommand{\cS}{\mathcal S}
\newcommand{\cT}{\mathcal T}
\newcommand{\cU}{\mathcal U}
\newcommand{\cV}{\mathcal V}
\newcommand{\cW}{\mathcal W}
\newcommand{\cX}{\mathcal X}
\newcommand{\cY}{\mathcal Y}
\newcommand{\cZ}{\mathcal Z}


% Brackets and such.
\newcommand{\abs}[1]{ \left\vert #1 \right\vert }
\newcommand{\mat}[1]{\begin{pmatrix} #1 \end{pmatrix}}
\newcommand{\norm}[1]{ \left\Vert #1 \right\Vert }
\newcommand{\tabs}[1]{ \vert #1 \vert }
\newcommand{\tnorm}[1]{ \Vert #1 \Vert }
\newcommand{\vertiii}[1]{{\left\vert\kern-0.25ex\left\vert\kern-0.25ex\left\vert #1 
    \right\vert\kern-0.25ex\right\vert\kern-0.25ex\right\vert}}


% Some typical math operators.
\DeclareMathOperator*{\argmax}{arg\,max}
\DeclareMathOperator*{\argmin}{arg\,min}
\newcommand{\laplace}{\Delta}
\renewcommand{\div}{\operatorname{div}}
\DeclareMathOperator*{\Sym}{Sym}
\DeclareMathOperator*{\Tr}{Tr}
\DeclareMathOperator*{\adj}{adj} % Adjugate


% Other math shortcuts/commands.
\renewcommand{\d}{\,\mathrm{d}}
\newcommand{\dd}[1]{ \frac{\partial}{\partial #1} }
\newcommand{\eps}{\varepsilon}
\providecommand{\op}[1]{\operatorname{#1}}
\newcommand{\wt}[1]{ \widetilde{#1} }


% Theorem environments.
\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{corollary}[theorem]{Corollary}
\newtheorem{proposition}[theorem]{Proposition}
\newtheorem{criterion}[theorem]{Criterion}
%~ \newtheorem{algorithm}[theorem]{Algorithm}

\newtheorem{definition}[theorem]{Definition}
%\newtheorem{assumption}[theorem]{Assumption}
\newtheorem{conjecture}[theorem]{Conjecture}
\newtheorem{example}[theorem]{Example}
\newtheorem{problem}[theorem]{Problem}
\newtheorem{remark}[theorem]{Remark}
\newtheorem{remarks}[theorem]{Remarks}
\newtheorem{xremark}[theorem]{Remark}
%\renewcommand{\theremark}{}
\newtheorem{note}{Note} 
\renewcommand{\thenote}{}
\newtheorem{claim}{Claim}
\newtheorem{summary}{Summary} 
\renewcommand{\thesummary}{}
\newtheorem{case}{Case}
\newtheorem{acknowledgement}{Acknowledgment}
\renewcommand{\theacknowledgement}{}  


% Numbering of equations and figures.
\numberwithin{equation}{section} 
\numberwithin{figure}{section}


% Colors.
% Useful tool: https://www.w3schools.com/colors/colors_picker.asp
\definecolor{darkgreen}{RGB}{0, 110, 0}
\definecolor{lightgrey}{rgb}{0.7,0.7,0.7}


% The \todo command.
\newcounter{todocounter}
\setcounter{todocounter}{0}
\newlength{\todowidthinner}
\setlength{\todowidthinner}{\marginparwidth}
\addtolength{\todowidthinner}{-2mm}
\newcommand{\todo}[1]{%
       \addtocounter{todocounter}{1}
       {\sf\bfseries  \framebox{\footnotesize%
%    To do%
       $^\text{\tiny\sf\arabic{todocounter}}$}}
       \marginpar{
               \framebox{\parbox[t]{\todowidthinner}{%
               \footnotesize\sf%
               \vskip-0pt
               #1
               }}%
               $\,^\text{\tiny\sf\arabic{todocounter}}$
       }%
}
\newcommand{\todolist}[1]{%
        \addtocounter{todocounter}{1}
        {\sf\bfseries  \framebox{\footnotesize To do $^\text{\tiny\sf\arabic{todocounter}}$}}
        \marginpar{
                \framebox{\parbox[t]{\todowidthinner}{%
                        \footnotesize\sf%
                        \vskip-0pt
                        \begin{list}{{$\bullet$\hskip-1mm}}%
                                {\setlength{\leftmargin}{2mm}}%
                                {\renewcommand{\\}{\item}%
                                        \item #1%
                                }%
                        \end{list}
                }}%
                $\,^\text{\tiny\sf\arabic{todocounter}}$
        }%
}


% Command to mark changes.
\usepackage{xifthen}%                       package needed to check for empty options
\usepackage{marginnote}%                    package for more flexible marginnotes
%\newcounter{todocounter}%         add new counter for margin notes
\setcounter{todocounter}{0}
\DeclareRobustCommand{\MyChange}[3][\empty]{%
  {\color{#2}#3}%                           color changed text
  \ifthenelse{\isempty{#1}}{}%              if option was supplied add it as margin note
  {%
    \addtocounter{todocounter}{1}%
    \ifmmode%
        {\color{#2}\text{$^{\framebox{\arabic{todocounter}}}$}}%
    \else%
        {\color{#2}\text{$^{\arabic{todocounter}}$}}%
    \fi%
    \marginpar{\textcolor{#2}{$^{\arabic{todocounter}}$\textnormal{#1}}}%
  }%
}
\usepackage[normalem]{ulem}%                package needed for striked out and undercurl text
%\newcommand{\SXout}[1]{\ifmmode{\color{lightgray}{#1}}\else\sout{\color{lightgray}{#1}}\fi}
\newcommand{\SXout}[1]{{\color{lightgray}{#1}}}

% Define TK change command with color red.
\newcommand{\TK}[2][]{\MyChange[#1]{red}{#2}}
\newcommand{\TKrm}[2][]{\TK[#1]{}{\SXout{#2}}}
\newcommand{\TKwave}[2][]{\TK[#1]{\uwave{#2}}}

% Define custom algorithmic environment. --> Does not really work, so it should just be done by hand for now.
\def\verbarg{{\scriptsize\makebox[2ex]{\arabic{VerbboxLineNo}}}\hspace{2ex}}
%~ \begin{verbnobox}[\verbarg]
%~ [CONTENT}
%~ \end{verbnobox}
% Drawback: Also no formuals accessible here --> not really suitable for much

